img.fmt.RGB32 <- 0x42475220
img.fmt.YV12 <- 842094169

run.mplayer <- function(file) {
    system(paste("mplayer ",system.file("libs",.Platform$r_arch,paste("videoTools",.Platform$dynlib.ext,sep=''),package="videoTools")," ",file,sep=''),wait=FALSE)
}

mplayer <- function(FUN=update.display, setup.FUN=new.display, format="RGB32", expand=TRUE, port=7922) {
    cat("start mplayer when ready:\nmplayer -vo dl:",system.file("libs",.Platform$r <- arch,paste("videoTools",.Platform$dynlib.ext,sep=''),package="videoTools"),"\n",sep='')
    if (is.character(format)) format <- fourcc2int(format)
    s=socketConnection(port=port,open="ab",server=TRUE)
    cat(" - mplayer connection established\n")
    first=TRUE
    while (TRUE) {
        b=readBin(s,"int",2)
        if (b[1]==1) { # accept_format
            c=readBin(s,"int",1)
            if (c==format) writeBin(65792L,s) else writeBin(131584L,s)
        }
        if (b[1]==2) { # dump_frame
            c=readBin(s,"int",4);
            if (first) { first=FALSE; w=c[1]; h=c[2]; setup.FUN(c[1],c[2]) }
            r=readBin(s,"raw",b[2]-16)
            if (c[3]==img.fmt.RGB32) {
                l=rawi42double(r,0,w*h*4,width=w)
                FUN(l[[1]],l[[2]],l[[3]])
            }
            if (c[3]==img.fmt.YV12) {
                if (expand)
                    FUN(raw2double(r,0,w*h,stride=w),
                        raw2double(r,w*h,w*h/4,stride=w/2,x.exp=2,y.exp=2),
                        raw2double(r,w*h*2,w*h/4,stride=w/2,x.exp=2,y.exp=2))
                else
                    FUN(raw2double(r,0,w*h,stride=w),
                        raw2double(r,w*h,w*h/4,stride=w/2),
                        raw2double(r,w*h*2,w*h/4,stride=w/2))
            }
        }
        if (b[1]==3) break; # close
        if (b[1]==4) { # begin
            c=readBin(s,"int",3)
            if (first) { first=FALSE; w=c[1]; h=c[2]; setup.FUN(c[1],c[2]) }
        }
    }
    invisible(TRUE)
}
